Index: trunk/src/shell32/enumidlist.c
===================================================================
--- trunk/src/shell32/enumidlist.c	(revision 7358)
+++ trunk/src/shell32/enumidlist.c	(revision 7359)
@@ -1,3 +1,3 @@
-/* $Id: enumidlist.c,v 1.2 2001-10-11 02:42:27 phaller Exp $ */
+/* $Id: enumidlist.c,v 1.3 2001-11-16 12:57:45 phaller Exp $ */
 /*
  *	IEnumIDList
@@ -24,15 +24,4 @@
 
 DEFAULT_DEBUG_CHANNEL(shell)
-
-/****************************************************************************
- * local prototypes
- ****************************************************************************/
-
-LPITEMIDLIST _Optlink ODIN_ILClone      (LPCITEMIDLIST pidl);
-
-void         _Optlink ODIN_SHFree   (LPVOID x);
-LPVOID       _Optlink ODIN_SHAlloc  (DWORD len);
-
-
 
 typedef struct tagENUMLIST
@@ -71,5 +60,5 @@
 
 	TRACE("(%p)->(pidl=%p)\n",This,pidl);
-	pNew = (LPENUMLIST)ODIN_SHAlloc(sizeof(ENUMLIST));
+	pNew = (LPENUMLIST)SHAlloc(sizeof(ENUMLIST));
 	if(pNew)
 	{
@@ -117,5 +106,5 @@
 
         TRACE("(%p)->(pidl=%p)\n",This,pidl);
-        pNew = (LPENUMLIST)ODIN_SHAlloc(sizeof(ENUMLIST));
+        pNew = (LPENUMLIST)SHAlloc(sizeof(ENUMLIST));
         if(pNew)
         {
@@ -471,6 +460,6 @@
 	{ pDelete = This->mpFirst;
 	  This->mpFirst = pDelete->pNext;
-	  ODIN_SHFree(pDelete->pidl);
-	  ODIN_SHFree(pDelete);
+	  SHFree(pDelete->pidl);
+	  SHFree(pDelete);
 	}
 	This->mpFirst = This->mpLast = This->mpCurrent = NULL;
@@ -633,5 +622,5 @@
 	    break;
 	  }
-	  temp = ODIN_ILClone(This->mpCurrent->pidl);
+	  temp = ILClone(This->mpCurrent->pidl);
 	  rgelt[i] = temp;
 	  This->mpCurrent = This->mpCurrent->pNext;
Index: trunk/src/shell32/pidl.c
===================================================================
--- trunk/src/shell32/pidl.c	(revision 7358)
+++ trunk/src/shell32/pidl.c	(revision 7359)
@@ -43,16 +43,6 @@
 
 
-/****************************************************************************
- * local prototypes
- ****************************************************************************/
-
-LPITEMIDLIST _Optlink ODIN_ILGetNext(LPITEMIDLIST pidl);
-LPITEMIDLIST _Optlink ODIN_ILClone  (LPCITEMIDLIST pidl);
-DWORD        _Optlink ODIN_ILGetSize(LPITEMIDLIST pidl);
-
-void         _Optlink ODIN_SHFree   (LPVOID x);
-LPVOID       _Optlink ODIN_SHAlloc  (DWORD len);
-
-
+#define ODIN_ILGETNEXT(pidl) \
+  (pidl ? ( pidl->mkid.cb ? (LPITEMIDLIST) (((LPBYTE)pidl)+pidl->mkid.cb) : NULL) : NULL)
 
 #if defined( __WIN32OS2__) && defined(DEBUG)
@@ -97,5 +87,5 @@
 	               pidltemp, pidltemp->mkid.cb,type,dwAttrib,szName,debugstr_a(szLongName), debugstr_a(szShortName));
 
-	      pidltemp = ODIN_ILGetNext(pidltemp);
+	      pidltemp = ODIN_ILGETNEXT(pidltemp);
 
 	    } while (pidltemp->mkid.cb);
@@ -165,5 +155,5 @@
 	      }
 	    }
-	    pidltemp = ODIN_ILGetNext(pidltemp);
+	    pidltemp = ODIN_ILGETNEXT(pidltemp);
 	  } while (pidltemp->mkid.cb);
 	}
@@ -198,5 +188,5 @@
 	{
 	  pidlLast = pidl;
-	  pidl = ODIN_ILGetNext(pidl);
+	  pidl = ODIN_ILGETNEXT(pidl);
 	}
 	return pidlLast;		
@@ -233,6 +223,6 @@
     return NULL;
     
-  len = ODIN_ILGetSize(pidl);
-  newpidl = (LPITEMIDLIST)ODIN_SHAlloc(len);
+  len = ILGetSize(pidl);
+  newpidl = (LPITEMIDLIST)SHAlloc(len);
   if (newpidl)
     memcpy(newpidl,pidl,len);
@@ -260,5 +250,5 @@
 	{
 	  len = pidl->mkid.cb;	
-	  pidlNew = (LPITEMIDLIST) ODIN_SHAlloc (len+2);
+	  pidlNew = (LPITEMIDLIST) SHAlloc (len+2);
 	  if (pidlNew)
 	  {
@@ -266,5 +256,5 @@
 
 	    if (len)
-	      ODIN_ILGetNext(pidlNew)->mkid.cb = 0x00;
+	      ODIN_ILGETNEXT(pidlNew)->mkid.cb = 0x00;
 	  }
 	}
@@ -291,5 +281,5 @@
 
 	if (*ppPidl)
-	{ ODIN_SHFree(*ppPidl);
+	{ SHFree(*ppPidl);
 	  *ppPidl = NULL;
 	}
@@ -298,10 +288,10 @@
 
 	if (SUCCEEDED(IStream_Read(pStream, (LPVOID)&wLen, 2, &dwBytesRead)))
-	{ *ppPidl = ODIN_SHAlloc (wLen);
+	{ *ppPidl = SHAlloc (wLen);
 	  if (SUCCEEDED(IStream_Read(pStream, *ppPidl , wLen, &dwBytesRead)))
 	  { ret = S_OK;
 	  }
 	  else
-	  { ODIN_SHFree(*ppPidl);
+	  { SHFree(*ppPidl);
 	    *ppPidl = NULL;
 	  }
@@ -310,5 +300,5 @@
 	/* we are not yet fully compatible */
 	if (!pcheck(*ppPidl))
-	{ ODIN_SHFree(*ppPidl);
+	{ SHFree(*ppPidl);
 	  *ppPidl = NULL;
 	}
@@ -342,5 +332,5 @@
         {
           wLen += sizeof(WORD) + pidl->mkid.cb;
-          pidl = ODIN_ILGetNext(pidl);
+          pidl = ODIN_ILGETNEXT(pidl);
         }
 
@@ -448,5 +438,5 @@
 	  return NULL;
     
-	len = ODIN_ILGetSize(pidl);
+	len = ILGetSize(pidl);
 	newpidl = (LPITEMIDLIST)pCOMCTL32_Alloc(len);
 	if (newpidl)
@@ -497,6 +487,6 @@
 	      return FALSE;
 
-	    pidl1 = ODIN_ILGetNext(pidl1);
-	    pidl2 = ODIN_ILGetNext(pidl2);
+	    pidl1 = ODIN_ILGETNEXT(pidl1);
+	    pidl2 = ODIN_ILGETNEXT(pidl2);
 	}
   
@@ -537,6 +527,6 @@
             return FALSE;
 
-	  pParent = ODIN_ILGetNext(pParent);
-	  pChild = ODIN_ILGetNext(pChild);
+	  pParent = ODIN_ILGETNEXT(pParent);
+	  pChild = ODIN_ILGETNEXT(pChild);
 	}	
 	
@@ -544,5 +534,5 @@
 	  return FALSE;
 	
-	if ( ODIN_ILGetNext(pChild)->mkid.cb && bImmediate)	/* not immediate descent */
+	if ( ODIN_ILGETNEXT(pChild)->mkid.cb && bImmediate)	/* not immediate descent */
 	  return FALSE;
 	
@@ -598,6 +588,6 @@
 	      break;
 
-	    pidltemp1 = ODIN_ILGetNext(pidltemp1);
-	    pidltemp2 = ODIN_ILGetNext(pidltemp2);
+	    pidltemp1 = ODIN_ILGETNEXT(pidltemp1);
+	    pidltemp2 = ODIN_ILGETNEXT(pidltemp2);
 	    ret = pidltemp2;	
 	  }
@@ -635,5 +625,5 @@
 	if(!pidl1)
 	{
-	  pidlNew = ODIN_ILClone(pidl2);
+	  pidlNew = ILClone(pidl2);
 	  return pidlNew;
 	}
@@ -641,11 +631,11 @@
 	if(!pidl2)
 	{
-	  pidlNew = ODIN_ILClone(pidl1);
+	  pidlNew = ILClone(pidl1);
 	  return pidlNew;
 	}
 
-	len1  = ODIN_ILGetSize(pidl1)-2;
-	len2  = ODIN_ILGetSize(pidl2);
-	pidlNew  = ODIN_SHAlloc(len1+len2);
+	len1  = ILGetSize(pidl1)-2;
+	len2  = ILGetSize(pidl2);
+	pidlNew  = SHAlloc(len1+len2);
 
 	if (pidlNew)
@@ -729,5 +719,5 @@
 
 /*************************************************************************
- * ODIN_ILGetNext [SHELL32.153]
+ * ODIN_ILGETNEXT [SHELL32.153]
  *  gets the next simple pidl of a complex pidl
  *
@@ -741,4 +731,7 @@
               LPITEMIDLIST, pidl)
 {
+#ifdef __WIN32OS2__
+  return ODIN_ILGETNEXT(pidl);
+#else
   WORD len;
 
@@ -750,4 +743,5 @@
   }
   return NULL;
+#endif
 }
 /*************************************************************************
@@ -774,7 +768,7 @@
 	if (_ILIsDesktop(pidl))
 	{
-	   idlRet = ODIN_ILClone(item);
+	   idlRet = ILClone(item);
 	   if (pidl)
-	     ODIN_SHFree (pidl);
+	     SHFree (pidl);
 	   return idlRet;
 	}
@@ -789,5 +783,5 @@
 	}
 
-	ODIN_SHFree(pidl);
+	SHFree(pidl);
 	return idlRet;
 }
@@ -805,5 +799,5 @@
   if(!pidl) 
     return FALSE;
-  ODIN_SHFree(pidl);
+  SHFree(pidl);
   return TRUE;
 }
@@ -1181,11 +1175,11 @@
 	  /* we are on desktop level */
 	  if (ppidlLast) 
-	    *ppidlLast = ODIN_ILClone(pidl);
+	    *ppidlLast = ILClone(pidl);
 	  hr = SHGetDesktopFolder((IShellFolder**)ppv);
 	}
 	else
 	{
-	  pidlChild =  ODIN_ILClone(ILFindLastID(pidl));
-	  pidlParent = ODIN_ILClone(pidl);
+	  pidlChild =  ILClone(ILFindLastID(pidl));
+	  pidlParent = ILClone(pidl);
 	  ILRemoveLastID(pidlParent);
 
@@ -1200,5 +1194,5 @@
 	    ILFree (pidlChild);
 
-	  ODIN_SHFree (pidlParent);
+	  SHFree (pidlParent);
 	  if (psf) IShellFolder_Release(psf);
 	}
@@ -1410,5 +1404,5 @@
 	}
 
-	if(!(pidlOut = ODIN_SHAlloc(uSize + 2))) return NULL;
+	if(!(pidlOut = SHAlloc(uSize + 2))) return NULL;
 	ZeroMemory(pidlOut, uSize + 2);
 	pidlOut->mkid.cb = uSize;
@@ -1446,5 +1440,5 @@
 	}
 	
-	pidlTemp = ODIN_ILGetNext(pidlOut);
+	pidlTemp = ODIN_ILGETNEXT(pidlOut);
 	if (pidlTemp)
 	  pidlTemp->mkid.cb = 0x00;
@@ -1466,5 +1460,5 @@
 
 	if(_ILIsMyComputer(pidl))
-	  pidl = ODIN_ILGetNext(pidl);
+	  pidl = ODIN_ILGETNEXT(pidl);
 
 	if (pidl && _ILIsDrive(pidl))
@@ -2022,6 +2016,6 @@
 	if(apidl)
 	{
-	  for(i = 0; i < cidl; i++) ODIN_SHFree(apidl[i]);
-	  ODIN_SHFree(apidl);
+	  for(i = 0; i < cidl; i++) SHFree(apidl[i]);
+	  SHFree(apidl);
 	}
 }
@@ -2035,9 +2029,9 @@
 {
 	int i;
-	LPITEMIDLIST * apidldest = (LPITEMIDLIST*)ODIN_SHAlloc(cidl * sizeof(LPITEMIDLIST));
+	LPITEMIDLIST * apidldest = (LPITEMIDLIST*)SHAlloc(cidl * sizeof(LPITEMIDLIST));
 	if(!apidlsrc) return NULL;
 
 	for(i = 0; i < cidl; i++)
-	  apidldest[i] = ODIN_ILClone(apidlsrc[i]);
+	  apidldest[i] = ILClone(apidlsrc[i]);
 
 	return apidldest;
@@ -2052,13 +2046,13 @@
 {
 	int i;
-	LPITEMIDLIST * dst = (LPITEMIDLIST*)ODIN_SHAlloc(cida->cidl * sizeof(LPITEMIDLIST));
+	LPITEMIDLIST * dst = (LPITEMIDLIST*)SHAlloc(cida->cidl * sizeof(LPITEMIDLIST));
 
 	if(!dst) return NULL;
 
 	if (pidl)
-	  *pidl = ODIN_ILClone((LPITEMIDLIST)(&((LPBYTE)cida)[cida->aoffset[0]]));
+	  *pidl = ILClone((LPITEMIDLIST)(&((LPBYTE)cida)[cida->aoffset[0]]));
 
 	for(i = 0; i < cida->cidl; i++)
-	  dst[i] = ODIN_ILClone((LPITEMIDLIST)(&((LPBYTE)cida)[cida->aoffset[i + 1]]));
+	  dst[i] = ILClone((LPITEMIDLIST)(&((LPBYTE)cida)[cida->aoffset[i + 1]]));
 
 	return dst;
Index: trunk/src/shell32/shlfolder.c
===================================================================
--- trunk/src/shell32/shlfolder.c	(revision 7358)
+++ trunk/src/shell32/shlfolder.c	(revision 7359)
@@ -46,18 +46,4 @@
 
 DEFAULT_DEBUG_CHANNEL(shell);
-
-
-/****************************************************************************
- * local prototypes
- ****************************************************************************/
-
-DWORD        _Optlink ODIN_ILFree       (LPITEMIDLIST pidl);
-LPITEMIDLIST _Optlink ODIN_ILCombine    (LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2);
-LPITEMIDLIST _Optlink ODIN_ILClone      (LPCITEMIDLIST pidl);
-LPITEMIDLIST _Optlink ODIN_ILCloneFirst (LPCITEMIDLIST pidl);
-LPITEMIDLIST _Optlink ODIN_ILGetNext    (LPITEMIDLIST pidl);
-
-void         _Optlink ODIN_SHFree   (LPVOID x);
-LPVOID       _Optlink ODIN_SHAlloc  (DWORD len);
 
 
@@ -145,11 +131,11 @@
 	  IShellFolder_Release(psfChild);
 
-	  pidlTemp = ODIN_ILCombine(*pidlInOut, pidlOut);
+	  pidlTemp = ILCombine(*pidlInOut, pidlOut);
 
 	  if (pidlOut) 
-	    ODIN_ILFree(pidlOut);
-	}
-
-	ODIN_ILFree(*pidlInOut);
+	    ILFree(pidlOut);
+	}
+
+	ILFree(*pidlInOut);
 	*pidlInOut = pidlTemp;
 
@@ -186,8 +172,8 @@
 	  if (SUCCEEDED(hr))
 	  {
-	    absPidl = ODIN_ILCombine (pidlRoot, pidlChild);
+	    absPidl = ILCombine (pidlRoot, pidlChild);
 	    hr = IPersistFolder_Initialize(pPersistFolder, absPidl);
 	    IPersistFolder_Release(pPersistFolder);
-	    ODIN_SHFree(absPidl);
+	    SHFree(absPidl);
 	    *ppvOut = pShellFolder;
 	  }
@@ -213,10 +199,10 @@
 	pdump(pidl);
 	
-	if ((pidlFirst = ODIN_ILCloneFirst(pidl)))
+	if ((pidlFirst = ILCloneFirst(pidl)))
 	{ 
 	  hr = IShellFolder_BindToObject(psf, pidlFirst, NULL, &IID_IShellFolder, (LPVOID*)&psfChild);
 	  if (SUCCEEDED(hr))
 	  {
-	    pidlNext = ODIN_ILGetNext(pidl);
+	    pidlNext = ILGetNext(pidl);
 
 	    hr = IShellFolder_GetDisplayNameOf(psfChild, pidlNext, dwFlags | SHGDN_INFOLDER, &strTemp);
@@ -228,5 +214,5 @@
 	    IShellFolder_Release(psfChild);
 	  }
-	  ODIN_ILFree(pidlFirst);
+	  ILFree(pidlFirst);
 	}
 
@@ -434,6 +420,6 @@
 	    TRACE("-- destroyed IShellFolder(%p) was Desktopfolder\n",This);
 	  }
-	  if(This->absPidl) ODIN_SHFree(This->absPidl);
-	  if(This->sMyPath) ODIN_SHFree(This->sMyPath);
+	  if(This->absPidl) SHFree(This->absPidl);
+	  if(This->sMyPath) SHFree(This->sMyPath);
 	  HeapFree(GetProcessHeap(),0,This);
 	  return 0;
@@ -544,5 +530,5 @@
 	  int len;
 
-	  sf->absPidl = ODIN_ILCombine(This->absPidl, pidl);	/* build a absolute pidl */
+	  sf->absPidl = ILCombine(This->absPidl, pidl);	/* build a absolute pidl */
 
 	  if (!_ILIsSpecialFolder(pidl))				/* only file system paths */
@@ -555,5 +541,5 @@
 
 	    dwSize += _ILSimpleGetText(pidl,NULL,0);		/* add the size of our name*/
-	    sf->sMyPath = ODIN_SHAlloc(dwSize + 2);			/* '\0' and backslash */
+	    sf->sMyPath = SHAlloc(dwSize + 2);			/* '\0' and backslash */
 
 	    if(!sf->sMyPath) return NULL;
@@ -778,8 +764,8 @@
 	     && SUCCEEDED(IShellFolder_QueryInterface(pShellFolder, &IID_IPersistFolder, (LPVOID*)&pPersistFolder)))
 	    {
-	      absPidl = ODIN_ILCombine (This->absPidl, pidl);
+	      absPidl = ILCombine (This->absPidl, pidl);
 	      IPersistFolder_Initialize(pPersistFolder, absPidl);
 	      IPersistFolder_Release(pPersistFolder);
-	      ODIN_SHFree(absPidl);
+	      SHFree(absPidl);
 	    }
 	    else
@@ -790,7 +776,7 @@
 	else if(_ILIsFolder(pidl))
 	{
-	  LPITEMIDLIST pidltemp = ODIN_ILCloneFirst(pidl);
+	  LPITEMIDLIST pidltemp = ILCloneFirst(pidl);
 	  pShellFolder = IShellFolder_Constructor(iface, pidltemp);
-	  ODIN_ILFree(pidltemp);
+	  ILFree(pidltemp);
 	}
 	else
@@ -806,5 +792,5 @@
 	else
 	{
-	  IShellFolder_BindToObject(pShellFolder, ODIN_ILGetNext(pidl), NULL, &IID_IShellFolder, (LPVOID)&pSubFolder);
+	  IShellFolder_BindToObject(pShellFolder, ILGetNext(pidl), NULL, &IID_IShellFolder, (LPVOID)&pSubFolder);
 	  IShellFolder_Release(pShellFolder);
 	  *ppvOut = pSubFolder;
@@ -909,10 +895,10 @@
 	    if (nReturn == 0)				/* first pidl different ? */
 	    {
-	      pidl1 = ODIN_ILGetNext(pidl1);
+	      pidl1 = ILGetNext(pidl1);
 
 	      if (pidl1 && pidl1->mkid.cb)		/* go deeper? */	
 	      {
-	        pidlTemp = ODIN_ILCloneFirst(pidl1);
-	        pidl2 = ODIN_ILGetNext(pidl2);
+	        pidlTemp = ILCloneFirst(pidl1);
+	        pidl2 = ILGetNext(pidl2);
 	
 	        hr = IShellFolder_BindToObject(iface, pidlTemp, NULL, &IID_IShellFolder, (LPVOID*)&psf);
@@ -923,9 +909,9 @@
 	          hr = ResultFromShort(nReturn);
 	        }
-	        ODIN_ILFree(pidlTemp);
+	        ILFree(pidlTemp);
 	      }
 	      else
 	      {
-	        pidl2 = ODIN_ILGetNext(pidl2);
+	        pidl2 = ILGetNext(pidl2);
 		if (pidl2 && pidl2->mkid.cb)		/* go deeper on #2 ? */
 		    hr = ResultFromShort(-1);           /* two different */
@@ -1079,7 +1065,7 @@
 	  else if (IsEqualIID(riid, &IID_IExtractIconA) && (cidl == 1))
 	  {
-	    pidl = ODIN_ILCombine(This->absPidl,apidl[0]);
+	    pidl = ILCombine(This->absPidl,apidl[0]);
 	    pObj = (LPUNKNOWN)IExtractIconA_Constructor( pidl );
-	    ODIN_SHFree(pidl);
+	    SHFree(pidl);
 	    hr = S_OK;
 	  } 
@@ -1489,7 +1475,7 @@
 	  pidlitem = SHSimpleIDListFromPathA(lpstrNewDir);
 
-	  pidl = ODIN_ILCombine(This->absPidl, pidlitem);
+	  pidl = ILCombine(This->absPidl, pidlitem);
 	  SHChangeNotifyA(SHCNE_MKDIR, SHCNF_IDLIST, pidl, NULL);
-	  ODIN_SHFree(pidl); 
+	  SHFree(pidl); 
 
 	  if (ppidlOut) *ppidlOut = pidlitem;
@@ -1554,7 +1540,7 @@
 	      return E_FAIL;
 	    }
-	    pidl = ODIN_ILCombine(This->absPidl, apidl[i]);
+	    pidl = ILCombine(This->absPidl, apidl[i]);
 	    SHChangeNotifyA(SHCNE_RMDIR, SHCNF_IDLIST, pidl, NULL);
-	    ODIN_SHFree(pidl); 
+	    SHFree(pidl); 
 	  }
 	  else if (_ILIsValue(apidl[i]))
@@ -1568,7 +1554,7 @@
 	      return E_FAIL;
 	    }
-	    pidl = ODIN_ILCombine(This->absPidl, apidl[i]);
+	    pidl = ILCombine(This->absPidl, apidl[i]);
 	    SHChangeNotifyA(SHCNE_DELETE, SHCNF_IDLIST, pidl, NULL);
-	    ODIN_SHFree(pidl); 
+	    SHFree(pidl); 
 	  }
 
@@ -1612,5 +1598,5 @@
 	      MESSAGE("would copy %s to %s\n", szSrcPath, szDstPath);
 	    }
-	    ODIN_SHFree(pidl);
+	    SHFree(pidl);
 	  }
 	  IPersistFolder2_Release(ppf2);
@@ -1821,6 +1807,6 @@
 	  /* combine pidls */
 	  SHGetSpecialFolderLocation(0, CSIDL_DESKTOPDIRECTORY, &deskpidl);
-	  firstpidl = ODIN_ILCloneFirst(pidl);
-	  completepidl = ODIN_ILCombine(deskpidl, firstpidl);
+	  firstpidl = ILCloneFirst(pidl);
+	  completepidl = ILCombine(deskpidl, firstpidl);
 
 	  pShellFolder = IShellFolder_Constructor(NULL, NULL);
@@ -1830,7 +1816,7 @@
 	    IPersistFolder_Release(ppf);
 	  }
-	  ODIN_ILFree(completepidl);
-	  ODIN_ILFree(deskpidl);
-	  ODIN_ILFree(firstpidl);
+	  ILFree(completepidl);
+	  ILFree(deskpidl);
+	  ILFree(firstpidl);
 	}
 	
@@ -1841,5 +1827,5 @@
 	else				/* go deeper */
 	{
-	  IShellFolder_BindToObject(pShellFolder, ODIN_ILGetNext(pidl), NULL, riid, (LPVOID)&pSubFolder);
+	  IShellFolder_BindToObject(pShellFolder, ILGetNext(pidl), NULL, riid, (LPVOID)&pSubFolder);
 	  IShellFolder_Release(pShellFolder);
 	  *ppvOut = pSubFolder;
@@ -2253,7 +2239,7 @@
 	  if (!_ILIsDrive(pidl)) return E_INVALIDARG;
 
-	  pidltemp = ODIN_ILCloneFirst(pidl);
+	  pidltemp = ILCloneFirst(pidl);
 	  pShellFolder = IShellFolder_Constructor(iface, pidltemp);
-	  ODIN_ILFree(pidltemp);
+	  ILFree(pidltemp);
 	}
 
@@ -2264,5 +2250,5 @@
 	else				/* go deeper */
 	{
-	  IShellFolder_BindToObject(pShellFolder, ODIN_ILGetNext(pidl), NULL, &IID_IShellFolder, (LPVOID)&pSubFolder);
+	  IShellFolder_BindToObject(pShellFolder, ILGetNext(pidl), NULL, &IID_IShellFolder, (LPVOID)&pSubFolder);
 	  IShellFolder_Release(pShellFolder);
 	  *ppvOut = pSubFolder;
@@ -2677,10 +2663,10 @@
 	if(This->absPidl)
 	{
-	  ODIN_SHFree(This->absPidl);
+	  SHFree(This->absPidl);
 	  This->absPidl = NULL;
 	}
 	if(This->sMyPath)
 	{
-	  ODIN_SHFree(This->sMyPath);
+	  SHFree(This->sMyPath);
 	  This->sMyPath = NULL;
 	}
@@ -2692,5 +2678,5 @@
 	if (SHGetPathFromIDListA(pidl, sTemp))
 	{
-	  This->sMyPath = ODIN_SHAlloc(strlen(sTemp)+1);
+	  This->sMyPath = SHAlloc(strlen(sTemp)+1);
 	  strcpy(This->sMyPath, sTemp);
 	}